// TD.h: interface for the CTD class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_TD_H__863623C1_F102_11D3_B759_9991C60B7470__INCLUDED_)
#define AFX_TD_H__863623C1_F102_11D3_B759_9991C60B7470__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "assert.h"
// #include "TetrisGame.h"

const double LAMBDA = 0.7;
const double ALPHA = 0.3;

class CTD  
{
public:
    inline void Update(int currState, int nextState, float immReward);
    float GetValue(int state) { return m_V[state]; }
	CTD(int nStates);
	CTD();
	virtual ~CTD();

private:
    int m_nSteps;
	int m_nStates;
    float *m_V;
};

inline void CTD::Update(int currState, int nextState, float immReward)
{
    assert(currState >= 0 && currState < m_nStates);
    assert(nextState >= 0 && nextState < m_nStates);

    m_nSteps++;
    // use a quite big alpha at the beginning, then reduce it in the 
    // order of (1/n) - which assures convergence.
//    float alpha = (float)((m_nSteps < 10 * 10000) ? ALPHA : 
//                                  (ALPHA / 10) / (m_nSteps / 100000));
    // let alpha be 1/n where 'n' is number of games (each includes 10k pieces)
    float alpha = (float)  ALPHA / (m_nSteps / 10000 + 1);
    m_V[currState] += (float)(alpha  * (immReward + LAMBDA * m_V[nextState] - 
                              m_V[currState]));
}
#endif // !defined(AFX_TD_H__863623C1_F102_11D3_B759_9991C60B7470__INCLUDED_)
