#include "TetrisGame.h"
//#include "Ql.h"
#include <math.h>
#include <stdio.h>
#include <stdlib.h> // for random policy

const int N_STATES = 2080;
const int N_GAMES = 256;
const int N_ACTIONS = N_ROTAT * GAME_WIDTH;
const int N_GAME_SHAPES = 10000;

void main ()
{
    CTD TD(N_STATES);
    for (int i = 0; i < N_GAMES; i++)
    {
        CTetrisGame game;
        bool topLevels[2][GAME_WIDTH];

        game.GetTopLevels(topLevels);
        int shapeIdx = game.DrawShape();
        int currState = game.Levels2State(topLevels);

        for (int j = 0; j < N_GAME_SHAPES; j++)
        {
            int rot, column, reward;

            game.GetBestAction(TD, shapeIdx, rot, column);

            reward = game.PerformAction(shapeIdx, rot, column);

            game.GetTopLevels(topLevels);

            int nextShapeIdx = game.DrawShape();
            int nextState = game.Levels2State(topLevels);

            // update states in symmetry table
            int symCurrState, symNextState;
            bool fMiror;

            game.State2SymState (currState, symCurrState, fMiror);
            game.State2SymState (nextState, symNextState, fMiror);

            TD.Update (symCurrState, symNextState, (float)reward);

            currState = nextState;
            shapeIdx = nextShapeIdx;
        }

        printf ("%03d  ", i+1);
        game.GetHeight();
    }
}
